﻿using System;
using System.Collections.Generic;
using Styx.WoWInternals;

using MurlocBuddy.Objects;
namespace MurlocBuddy.MLua
{
    class C_PetBattles
    {
        public static bool ActivePetIsDie(int petOwner)
        {
            return Lua.GetReturnVal<bool>(string.Format("usable = 'false'; if (C_PetBattles.GetHealth({0},C_PetBattles.GetActivePet({0}))== 0) then usable = 'true' end; return usable", petOwner), 0);
        }
        public static void AcceptQueuedPVPMatch()
        {
            Lua.DoString("C_PetBattles.AcceptQueuedPVPMatch()");
        }
        public static void ChangePet(int petIndex)
        {
            Lua.DoString(string.Format("C_PetBattles.ChangePet('{0}')", petIndex));
        }

        public static List<string> GetAbilityInfo(int petOwner, int petIndex, int abilityIndex)
        {
            ///id, name, icon, maxCooldown, unparsedDescription, numTurns, petType, noStrongWeakHints
           return  Lua.GetReturnValues(string.Format("return C_PetBattles.GetAbilityInfo({0}, {1}, {2})", petOwner, petIndex, abilityIndex));      
        }


        public static Ability GetAbilityInfoByID(int abilityID)
        {
            ///id, name, icon, maxCooldown, unparsedDescription, numTurns, petType, noStrongWeakHints
            List<string> LPetAbility = Lua.GetReturnValues(string.Format("return C_PetBattles.GetAbilityInfoByID('{0}')", abilityID));
            Ability petAbility = new Ability();

            petAbility.id = Convert.ToInt32(LPetAbility[0]);
            petAbility.name = LPetAbility[1];
            petAbility.icon = LPetAbility[2];
            petAbility.maxCooldown = Convert.ToInt32(LPetAbility[3]);
            petAbility.unparsedDescription = LPetAbility[4];
            petAbility.numTurns = Convert.ToInt32(LPetAbility[5]);
            petAbility.petType = Convert.ToInt32(LPetAbility[6]);
            if (LPetAbility[7] == "0") petAbility.noStrongWeakHints = false;        
            else petAbility.noStrongWeakHints =  true;

            return petAbility;
        }





        public static double GetAttackModifier(int petType, int enemyPetType)
        {
            return Lua.GetReturnVal<double>(string.Format("return C_PetBattles.GetAttackModifier({0}, {1});", petType, enemyPetType), 0);
        }

        public static List<string> GetAuraInfo(int petOwner, int petIndex, int auraIndex)
        {
            ///auraID, instanceID, turnsRemaining, isBuff
            return Lua.GetReturnValues(string.Format("return C_PetBattles.GetAuraInfo({0}, {1}, {2})", petOwner, petIndex, auraIndex));      
        }

        public static bool GetAbilityState(int petOwner, int petIndex, int abilityIndex)
        {
            return Lua.GetReturnVal<bool>(string.Format("state = C_PetBattles.GetAbilityState({0}, {1}, {2}); return state;", petOwner, petIndex, abilityIndex), 0);
        }
        public static int GetActivePet(int petOwner)
        {
            return Lua.GetReturnVal<int>(string.Format("return C_PetBattles.GetActivePet({0});", petOwner), 0);
        }


        public static PetBattleState GetBattleState()
        {
            return (PetBattleState)Lua.GetReturnVal<int>("return C_PetBattles.GetBattleState();", 0);
        }



        public static int GetBreedQuality(int petOwner, int petIndex)
        {
            return Lua.GetReturnVal<int>(string.Format("return C_PetBattles.GetBreedQuality({0}, {1})", petOwner, petIndex), 0);       
        }

        public static int GetNumAuras(int petOwner, int petIndex)
        {
            return Lua.GetReturnVal<int>(string.Format("return C_PetBattles.GetNumAuras({0}, {1});", petOwner, petIndex), 0);
        }

        public static int GetNumAbility(int petOwner, int petIndex)
        {
            return Lua.GetReturnVal<int>(string.Format("b = 0; for i=3,1,-1 do id = C_PetBattles.GetAbilityInfo({0},{1},i); if(id ~= nil) then b = b+1; end; end; return b;", petOwner, petIndex), 0);
        }

        public static int GetNumPets(int petOwner)
        {
            return Lua.GetReturnVal<int>(string.Format("return C_PetBattles.GetNumPets({0});", petOwner), 0);
        }

        public static int GetHealth(int petOwner, int petIndex)
        {
            return Lua.GetReturnVal<int>(string.Format("return C_PetBattles.GetHealth({0}, {1})", petOwner, petIndex), 0); 
        }


        public static int GetLevel(int petOwner, int petIndex)
        {
            return Lua.GetReturnVal<int>(string.Format("return C_PetBattles.GetLevel({0}, {1})", petOwner, petIndex), 0);    
        }


        public static int GetStateValue(int petOwner, int petIndex, int stateID)
        {
            return Lua.GetReturnVal<int>(string.Format("return C_PetBattles.GetStateValue({0}, {1}, {2})", petOwner, petIndex, stateID), 0);    
        }

        public static int GetMaxHealth(int petOwner, int petIndex)
        {
            return Lua.GetReturnVal<int>(string.Format("return C_PetBattles.GetMaxHealth({0}, {1})", petOwner, petIndex), 0);
        }

        public static int GetPetType(int petOwner, int petIndex)
        {
            return Lua.GetReturnVal<int>(string.Format("return C_PetBattles.GetPetType({0}, {1});", petOwner, petIndex), 0);
        }


        public static int GetPower(int petOwner, int petIndex)
        {
            return Lua.GetReturnVal<int>(string.Format("return C_PetBattles.GetPower({0}, {1});", petOwner, petIndex), 0);
        }

        public static string GetPVPMatchmakingInfo()
        {
            return Lua.GetReturnVal<string>("queueState = C_PetBattles.GetPVPMatchmakingInfo(); return queueState;", 0);
        }

        public static int GetSpeed(int petOwner, int petIndex)
        {
            return Lua.GetReturnVal<int>(string.Format("return C_PetBattles.GetSpeed({0}, {1});", petOwner, petIndex), 0);
        }

        public static bool IsInBattle()
        {
            return Lua.GetReturnVal<bool>("return C_PetBattles.IsInBattle();", 0);
        }

        public static bool IsTrapAvailable()
        {
            return Lua.GetReturnVal<bool>("return C_PetBattles.IsTrapAvailable();", 0);
        }

        public static bool IsWaitingOnOpponent()
        {
            return Lua.GetReturnVal<bool>("return C_PetBattles.IsWaitingOnOpponent();", 0);
        }

        public static int GetHealth()
        {
            return Lua.GetReturnVal<int>("return C_PetBattles.GetHealth(1, 1);", 0); 
        }

        public static void UseAbility(int actionIndex)
        {
           Lua.DoString(string.Format("C_PetBattles.UseAbility({0});", actionIndex));
        }

        public static void SkipTurn()
        {
          Lua.DoString("C_PetBattles.SkipTurn();");
        }

        public static void StartPVPMatchmaking()
        {
            Lua.DoString("C_PetBattles.StartPVPMatchmaking()");
        }

        public static void UseTrap()
        {
            Lua.DoString("C_PetBattles.UseTrap();");
        }

    }
}
