﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MurlocBuddy.MLua;
using MurlocBuddy;

namespace MurlocBuddy.Objects
{
    public class Pet
    {
        int PetOwner, PetIndex;
   //     public string Name { get { return Lua.C_PetBattles.GetName(PetOwner, PetIndex).Name; } }
     //   public string speciesName { get { return Lua.C_PetBattles.GetName(PetOwner, PetIndex).speciesName; } }

       // public int numAuras { get { return Lua.C_PetBattles.GetNumAuras(PetOwner, PetIndex); } }

     //   public int BreedQuality { get { return Lua.C_PetBattles.GetBreedQuality(PetOwner, PetIndex); } }

        public int Power { get { return MLua.C_PetBattles.GetPower(PetOwner, PetIndex); } }
        public int Speed { get { return MLua.C_PetBattles.GetSpeed(PetOwner, PetIndex); } }
        public int Type { get { return MLua.C_PetBattles.GetPetType(PetOwner, PetIndex); } }

        public BattlePetQuality Quality { get { return (BattlePetQuality)MLua.C_PetBattles.GetBreedQuality(PetOwner, PetIndex); } }

        public int Health { get { return MLua.C_PetBattles.GetHealth(PetOwner, PetIndex); } }
        public double HealthPercent { get { return ( (double)Health / (double)MaxHealth * 100); } }
        public int MaxHealth { get { return MLua.C_PetBattles.GetMaxHealth(PetOwner, PetIndex); } }
        public int Level { get { return MLua.C_PetBattles.GetLevel(PetOwner, PetIndex); } }



        public List<Ability> ability()
        {
            List<Ability> abi = new List<Ability>();

            for (int x = 1; x <= C_PetBattles.GetNumAbility(PetOwner, PetIndex); x++)
            {
                Ability abils = new Ability(PetOwner, PetIndex, x);
                abils.spellIndex = x;
                abi.Add(abils);
            }

            return abi;
        }

        public List<Aura> aura()
        {
            List<Aura> au = new List<Aura>();
            for (int x = 1; x <= MLua.C_PetBattles.GetNumAuras(PetOwner, PetIndex); x++)
            {
                Aura aur = new Aura(PetOwner, PetIndex, x);
                au.Add(aur);
            }

            return au;
        }

        public bool HasAuraId(int auraId)
        {

            for (int x = 1; x <= MLua.C_PetBattles.GetNumAuras(PetOwner, PetIndex); x++)
            {
                Aura aur = new Aura(PetOwner, PetIndex, x);
                if (aur.auraID == auraId) return true;
            }
            return false;

        }

        public Pet(int petOwner, int petIndex)
        {
            PetOwner = petOwner;
            PetIndex = petIndex;
        }
    }



    struct Rarity
    {
        public const int Poor = 1;
        public const int Common = 2;
        public const int Uncommon = 3;
        public const int Rare = 4;
        public const int Epic = 5;
        public const int Legendary = 6;
    }





}
